*
* QCONFIG.MM:  Config file for QEdit 2.x to emulate MultiMate.
*
*
* Specify control-key commands via: ^f1 - This means Control-F1
* Specify alt-key commands via: @f1     - This means Alt-F1
* Specify shift-key commands via: #f1   - This means Shift-F1
*
* There is also a provision for "two key commands".
* For example, to make the Control-F1, Control-F2 sequence issue the
* exit command, try the following:
*
* ^f1_^f2     Exit
*
* The key here is that the commands must be separated by a '_'.
*
* Multiple commands and/or text may be entered for a single key.  To do so,
* specify "MacroBegin" as the first command.  To enter text, enclose the
* text in single or double quote marks.  For example:
*
* f1  MacroBegin EditFile 'help.dat' Return
*
* This command would load the file 'help.dat'.  Note the return command is
* issued after the text.  This is required to terminate the QEdit prompt.
*
* Following is a macro that will run make and load the results into a window:
*
* MacroBegin EditFile 'errors.lst' Return Quit Dos 'make >errors.lst' Return Return HorizontalWindow  EditFile 'errors.lst' Return
*
* Following macro will run Turbo C on the current file:
*
* MacroBegin GSave Dos 'tcc -y -M ' CurrentFilename Return
*
* Finally, you can also use the scancode to represent "special keys", as
* long as this key returns a ascii character code of 0.
* For example Alt-F9 returns an ascii character of 0 and a scan code of
* 112 decimal.  To make Alt-F9 issue the EditFile command, you could:
*
* 112  EditFile
*     or
* @f9  EditFile
*
* Either will work.  This becomes especially useful if you have a macro
* processor and/or special keyboard that has extended keys that QEdit
* doesn't have names for.  This gives you a method to use them.
*
* Note that the order of this file is NOT important.  Arrange it however
* makes sense to you.
*

*
* function key set
*

*f1               QuickHelp
*
f1              GotoLine
*
* f2                AddLine
* in MM f2 is page break.  I'm doing a Form Feed
*
f2               MacroBegin ""
* f3               GPQuit
* in MM f3 put the cursor at the center of the line then expands in both
* directions as you type.  I'm centering the line after it is typed.
*
f3               CenterLine
*f4               DupLine
* not sure exactly what indent does.  seems to tab right.
f4               TabRt
*
* we do not have a library so I left it alone
f5               MakeTopOfScreen
*f6               DelToEol
*
f6               Find
*
*f7               MarkBlockBegin
* does not work exactly like like mm
f7              MacroBegin MarkCharacter Pause MarkCharacter Pause MoveBlock
*
*f8               MarkBlockEnd
* does not work exactly like like mm
f8              MacroBegin MarkCharacter Pause MarkCharacter Pause CopyBlock
*
f9               Shell
f10              GExit

* enhanced keyboard only
f11
f12

*#f1              ToggleBoxDraw
*
#f1              QuickHelp
*
* we have no default #f2
#f2              MacroBegin Find "" Return "i" Return JFalse over: Delch over: PrevPosition
#f3              Sort
*
#f4              FindReplace
*
#f5              MakeCtrOfScreen
#f6
#f7              ShiftLeft
#f8              ShiftRight
#f9
*
#f10             SaveFile
*

* enhanced keyboard only
#f11
#f12

^f1              ToggleEGA43
^f2
^f3
^f4
^f5             MacroRecord
^f6
^f7
* MM loads and executes the macro.  This can not be done so we just
* load the macro
^f8             MacroRead
^f9
^f10

* enhanced keyboard only
^f11
^f12

@f1              ToggleBoxType
*@f2              InsertLine
* set page length. not exactly like mm because we do not have real
* page breaks
@f2             SetPrintPageSize
*
@f3              Match
@f4
@f5              ScreenLeft
@f6              ScreenRight
@f7
@f8
@f9              Dos
@f10             ShowEntryScreen

* enhanced keyboard only
@f11
@f12

*
* special keys
*

cursorup         CursorUp
cursordown       CursorDown
*cursorleft       CursorLeft
*cursorright      CursorRight
*
cursorleft    MacroBegin CursorLeft JTrue end: CursorUp JFalse end: EndLine end:
cursorright   MacroBegin EndLine JFalse down: PrevPosition CursorRight Jump end: down: CursorDown JFalse end: BegLine end:
*
*^cursorleft      WordLeft
*^cursorright     WordRight
^cursorleft     MacroBegin again: WordLeft JFalse end: Endline JFalse again: PrevPosition end:
^cursorright    MacroBegin again: WordRight JFalse end: Endline JFalse again: PrevPosition end:
*home             BegLine
*
home            MacroBegin BegScreen BegLine
*
*end              EndLine
*
end             MacroBegin EndScreen EndLine
*
^home            BegScreen
^end             EndScreen
pgup             PageUp
pgdn             PageDown
^pgdn            EndFile
^pgup            BegFile

#tab             TabLt
tab              TabRt

ins              ToggleInsert
del              DelCh

backspace        Backspace
^backspace       DelLtWord

enter            Return
^enter           ExecuteScrap

escape           Escape

grey*            Paste
grey+            Copy
grey-            Cut
#del
#ins
`
~
/

^prtsc           PasteOver
^2               Shell
* import ascii
*
^6              MacroBegin ReadBlock Pause Return UnMarkBlock
*
^[
^\
*
* Macro to edit the file whose name is sitting at the cursor in the editor
*
^]                 MacroBegin AltWordSet MarkWord Copy DefaultWordSet EditFile Paste Return
^-                 GetPrev

*
* alternate keys
*

@a               DropAnchor
*@b               WrapPara
* page Break
@b              MacroBegin #12
*
@c               CopyBlock
@d               DelLine
* @e               EditFile
* our default for alt e is editfile
@e              ToggleBoxDraw
*
@f               MacroBegin MainMenu 'f'
@g               DeleteBlock
@h               QuickHelp
@i               ToggleTabsOut
@j               JoinLine
@k               MarkColumn
*
*@l               MarkLine
* pull down menus
@l               MainMenu
*
@m               MoveBlock
@n               NextFile
@o               ChangeFilename
@p               MacroBegin MainMenu 'p'
@q               MacroBegin MainMenu 'q'
*@r               ReadBlock
* execute macro -- works on scrap macro
@r              ExecuteScrap
*
@s               SplitLine
@t
@u               UnmarkBlock
@v               ToggleTabsExpand
@w               WriteBlock
@x               GExit
@y               GSave
@z               CopyOverBlock
* @1               Upper
*
@1               EditFile
*
* @2               Lower
* editfile and create file are the same in QEdit.
*
@2               EditFile
*
* @3               Flip
* print the whole doc
@3               PrintAll
*
* additional print functions
@4               MacroBegin MainMenu 'p'
@5
@6
@7
@8
@9               GExit
@0
@-
@=               MacroBegin MarkWord Copy Find Paste Return Return

*
* control keys
*


^a               WordLeft
^b_a             AppendScrBuff
^b_l             GetScrBuff
^b_s             StoreScrBuff
^c               PageDown
^d               CursorRight
^e               CursorUp
^f               WordRight
^g               DelCh
^h               Backspace
^i               TabRt
^j               GotoLine
^k_b             MarkBlockBegin
^k_c             CopyBlock
^k_d             Exit
^k_e             EditFile
^k_f             ChangeFilename
^k_h             UnmarkBlock
^k_k             MarkBlockEnd
^k_l             FillBlock
^k_n             NextFile
^k_p             PrevFile
^k_q             PQuit
^k_r             ReadBlock
^k_s             SaveFile
^k_t             MarkWord
^k_v             MoveBlock
^k_w             WriteBlock
^k_x             File
^k_y             DeleteBlock
^k_z             KillFile
^l               RepeatFind
^m               MacroRecord
^n               SplitLine
^o_c             CloseWindow
^o_g             GrowWindow
^o_h             HorizontalWindow
^o_l             SetPrintLeftMargin
^o_n             NextWindow
^o_o             OneWindow
^o_p             PrevWindow
^o_r             SetRMargin
^o_s             ShrinkWindow
^o_t             CenterLine
^o_w             ToggleWordWrap
^o_z             ZoomWindow
^p               Literal
^q_a             FindReplace
^q_b             GotoBlockBeg
^q_c             EndFile
^q_d             EndLine
^q_e             BegScreen
^q_f             Find
^q_i             ToggleIndent
^q_k             GotoBlockEnd
^q_l             UndoCursorline
^q_p             PrevPosition
^q_q             RepeatCmd
^q_r             BegFile
^q_s             BegLine
^q_t             ToggleSmartTabs
^q_x             EndScreen
^q_y             DelToEol
^r               PageUp
^s               CursorLeft
^t               DelRtWord
^u               UnKill
^v               ToggleInsert
^w               ScrollUp
^x               CursorDown
^y               DelLine
^z               ScrollDown

*
* other enhanced only keys
*
@'
@,
@.
@/
@;
@[
@\
@]
@`
@backspace
@enter
@escape
@grey*
@grey+
@grey-
@grey/
@greycursordown
@greycursorleft
@greycursorright
@greycursorup
@greydel
@greyend
@greyhome
@greyins
@greypgdn
@greypgup
@greyenter
@tab

greyenter        Return
^greyenter       ExecuteScrap
^centercursor
^cursordown      LineDown
^cursorup        LineUp
^del

^grey*
^grey+
^grey-
^grey/
^ins
^tab

centercursor
