/************************************************************************/
/* FEDIT.h - Global Definitions Header File				*/
/************************************************************************/

#ifndef   BOOLTYPE
  #define BOOLTYPE 0
  typedef unsigned short int BOOL;
#endif

#ifndef   BYTETYPE
  #define BYTETYPE 0
  typedef unsigned char BYTE;
#endif

#define SUCCESS		0	/* Function succeeded			*/
#define FAIL		-1	/* Function unsuccessful		*/
#define EXIT		1	/* Exit Program switch			*/
#define CANCEL		27	/* Escape key				*/
#define EVER		;;	/* used in "for (EVER)"			*/
#define FALSE		0
#define TRUE		!FALSE
#define NO_KEY		0	/* Keyboard status			*/
#define BS		8	/* Backspace Key			*/
#define BKSLASH		92	/* \	*/

/* Colors for 16 color monitors	*/

#define	Black		0
#define	Blue		1
#define	Green		2
#define	Cyan		3
#define	Red		4
#define	Magenta		5
#define	Brown		6
#define	LightGrey	7
#define	DarkGrey	8
#define	LightBlue	9
#define	LightGreen	10
#define	LightCyan	11
#define	LightRed	12
#define	LightMagenta	13
#define	Yellow		14
#define	BrightWhite	15
#define	StdAttr		LightGrey
#define	ReverseVideo	(Blue << 4) | BrightWhite

/* Standard Function Keys	*/

#define F1		182
#define F2		183
#define F3		184
#define F4		185
#define F5		186
#define F6		187
#define F7		188
#define F8		189
#define F9		190
#define F10		191
#define F11		192
#define F12		193

/* Navigation Keys	*/

#define TAB		9	/* Tab Key				*/
#define SHFT_TAB	138	/* Back Tab				*/
#define HOME		194	/* Home key				*/
#define UP		195	/* Up arrow				*/
#define PGUP		196	/* PgUp key				*/
#define LEFT		198	/* Left arrow				*/
#define RIGHT		200	/* Right arrow				*/
#define END		202	/* End key				*/
#define DOWN		203	/* Down arrow				*/
#define PGDN		204	/* PgDn key				*/
#define CTL_LEFT	238	/* ^Left arrow				*/
#define CTL_RIGHT	239	/* ^Right arrow				*/
#define CTL_END		240	/* ^End					*/
#define CTL_PGDN	241	/* ^PgDn				*/
#define CTL_HOME	242	/* ^Home				*/
#define CTL_PGUP	255	/* ^PgUp				*/

/* Line Drawing Set	*/

#define TLCW		201	/* Top Left Corner (Wide)		*/
#define TRCW		187	/* Top Right Corner (Wide)		*/
#define HORIZW		205	/* Horizontal Bar (Wide)		*/
#define VERTW		186	/* Vertical Bar (Wide)			*/
#define BLCW		200	/* Bottom Left Corner (Wide)		*/
#define BRCW		188	/* Bottom Right Corner (Wide)		*/

/************************************************************************/
/* Global Function Prototypes		            			*/
/************************************************************************/

int DisplayRecord(long rrn);
void ShowChar(int pos,int attr);
int ReadRecord(long rrn);
int WriteRecord();

/************************************************************************/
/* Global Utility Function Prototypes	            			*/
/************************************************************************/

void WriteCharacter(unsigned ch,int attr);
void WriteString(char *str,int attr);
void Cprintf(int row,int col,unsigned attr,char *format,...);
void ShowMessage(char *format,...);
unsigned Wait(char *prompt);
unsigned GetYesNo(char *prompt);
void DrawBox(int trow,int lcol,int brow,int rcol,unsigned attr);
void ClearMessage(),ClearCommand();
void ClearWindow(int trow,int lcol,int brow,int rcol);
void SetCursor(int row,int col);
unsigned Row(),Col();
unsigned InKey(),GetKey();
char *GetString(char *prompt,int cnt);
char *EditDate(unsigned date);
char *EditTime(unsigned time);
unsigned Convert2Hex(unsigned hex);
void DosErrMsg();
