echo off

echo This is a demonstration of PED4DOS's facilities
echo Please don't overwrite the input files.
echo Use the "save as" option to write changes
echo to another file, if you want to see the result
echo of modifications.
echo Otherwise: backup the files DEMO.IN and LIST.IN
echo and restore them after the demonstration
choice /c:yn "start demo "
if errorlevel 2 goto stop

echo ---------------------------		
echo search for multiple strings
echo ---------------------------		
echo on
..\bin\p4d demo.in "'editor';'string';'search';'replac';'exampl'" /nologo
echo off
choice /c:yn "continue demo "
if errorlevel 2 goto stop


echo ------------------------------------------
echo search and replace multiple strings
echo (replace abbreviations by their expansion)
echo ------------------------------------------
echo on
..\bin\p4d demo.in "'sq' wo = 'Software-Quelle';'p4d' wo = 'PED4DOS';'MS' wo ='Microsoft'" /nologo
echo off
choice /c:yn "continue demo "
if errorlevel 2 goto stop



echo ---------------------------------------------------
echo exchange 2 words separated by spaces and/or newline
echo ---------------------------------------------------
echo on
..\bin\p4d demo.in "*(l) + *(ws+nl) + *(l) = *3 + *2 + *1" /nologo
echo off
choice /c:yn "continue demo "
if errorlevel 2 goto stop


echo ---------------------------------------------------
echo exchange 2 words separated by spaces and/or newline
echo second version using string variables
echo will reverse the previous changes
echo ---------------------------------------------------
echo on
..\bin\p4d demo.in "*(l)>$word1 + *(ws+nl)>$sp + *(l)>$word2 = $word2 + $sp + $word1" /nologo
echo off
choice /c:yn "continue demo "
if errorlevel 2 goto stop


echo ------------------------------		
echo search in the first 10 columns
echo ------------------------------		
echo on
..\bin\p4d demo.in "<1 .. 10> 'file'" /nologo
echo off
choice /c:yn "continue demo "
if errorlevel 2 goto stop


echo ------------------------------------------		
echo demonstration of expressions and functions 
echo ------------------------------------------		
echo the search program contains multiple lines
echo the search program will be started in trace mode
echo so you will see each statement before execution
choice /c:yn "do you want the search program to be displayed "
if errorlevel 2 goto exec_expr
type expr.prg | more
choice /c:yn "execute the search program "
if errorlevel 2 goto end_expr
:exec_expr
echo choose the trace option to step to the next statement		
echo on
..\bin\p4d demo.in /f:expr.prg /nologo /p:-dm /trace
echo off
:end_expr		
choice /c:yn "continue demo "
if errorlevel 2 goto stop


echo ---------------------------------		
echo count words and show only the sum
echo ---------------------------------		
echo on
..\bin\p4d demo.in "*(l)" /nologo /p:-dm
echo off
choice /c:yn "continue demo "
if errorlevel 2 goto stop


echo -----------------------------	
echo count words, lines and spaces
echo -----------------------------
echo the search program contains multiple lines
choice /c:yn "do you want the search program to be displayed "
if errorlevel 2 goto exec_count
type count.prg | more
choice /c:yn "execute the search program "
if errorlevel 2 goto end_count
:exec_count		
echo on
..\bin\p4d demo.in /f:count.prg /nologo /p:-dm
echo off
:end_count		
choice /c:yn "continue demo "
if errorlevel 2 goto stop


echo ------------------------------------------
echo center lines that do not begin in column 1
echo ------------------------------------------
echo the search program contains multiple lines
choice /c:yn "do you want the search program to be displayed "
if errorlevel 2 goto exec_center
type center.prg | more
choice /c:yn "execute the search program "
if errorlevel 2 goto end_center
:exec_center		
echo on
..\bin\p4d demo.in /f:center.prg /p:-dm /nologo
echo off
:end_center		
choice /c:yn "continue demo "
if errorlevel 2 goto stop


echo -------------------------------------------------	
echo set the FILES value in config.sys to at least 128
echo -------------------------------------------------
echo the search program contains multiple lines
choice /c:yn "do you want the search program to be displayed "
if errorlevel 2 goto exec_files
type files.prg | more
choice /c:yn "execute the search program "
if errorlevel 2 goto end_files
:exec_files		
echo on
..\bin\p4d config.sys /f:files.prg /nologo /p:-dm
echo off
:end_files
choice /c:yn "continue demo "
if errorlevel 2 goto stop


echo -----------------------------------------------------------	
echo select data from a list file to serve as input for MS-Excel
echo first version using output to a log file
echo -----------------------------------------------------------
echo the search program contains multiple lines
choice /c:yn "do you want the search program to be displayed "
if errorlevel 2 goto exec_list1
type list1.prg | more
choice /c:yn "execute the search program "
if errorlevel 2 goto end_list1
:exec_list1		
echo on
..\bin\p4d list.in /f:list1.prg /l:list.out /nologo /p:-dm
echo off
choice /c:yn "do you want to see the log file "
if errorlevel 2 goto end_list1
type list.out | more
:end_list1		


echo -------------------------------------------------	
echo modify a list file to serve as input for MS-Excel
echo second version modifying the input file
echo -------------------------------------------------
echo the search program contains multiple lines
choice /c:yn "do you want the search program to be displayed "
if errorlevel 2 goto exec_list2
type list2.prg | more
choice /c:yn "execute the search program "
if errorlevel 2 goto end_list2
:exec_list2		
echo on
..\bin\p4d list.in /f:list2.prg /nologo /p:-dm
echo off
:end_list2
choice /c:yn "continue demo "
if errorlevel 2 goto stop



:stop
echo ------------------------------------------------
echo End of the demonstration of PED4DOS's facilities
echo ------------------------------------------------
